/* CallWin32Podule.h
Defines the podule's functionality
Original by Graeme Barnes: My changes (C) 2002 Niall Douglas
8th August 2002 (started: 16th July 2002)

My changes are provided under the GNU General Public Licence.
See the file gpl.txt in the archive for more information.
*/

#if !defined(AFX_TIMERPODULE1_H__C1A65D8B_3C44_4D33_A5BC_98FEFBE56526__INCLUDED_)
#define AFX_TIMERPODULE1_H__C1A65D8B_3C44_4D33_A5BC_98FEFBE56526__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "IocPodule.h"

#define PARS_MAX 16
#define PARDATA_MAX 16384
class CCallWinPodule : public CIocPodule  
{
	DECLARE_COMPONENT(CCallWinPodule);

	Byte*		rombase;	// base of rom image
	Word		romsize;	// size of rom image

	Word		rompage;	// rom page register
	Word		int_status, int_mask;
	Word		vector;		// Vector being called

	Word RAMoffset;

	char DLLname[64], APIname[64];
	Word errorcode;
	DWORD lasterror;		// From GetLastError()
	int currentpar, totalpars;
	Word pars[PARS_MAX];
	struct ParData
	{
		int idx;
		char data[PARDATA_MAX/sizeof(char)];
	} pardata[PARS_MAX];

public:
	CCallWinPodule();
	virtual ~CCallWinPodule();

	// CComponent interface
	virtual BOOL Init();
	virtual BOOL Cleanup();
	virtual BOOL Connect();
	virtual BOOL Disconnect();
	// Vector interface
	void CallVector(Word v);
	// IocPodule interface
	virtual Byte ReadByte(Word address);
	virtual void WriteByte(Word address, Byte b);
	virtual Word ReadWord(Word address);
	virtual void WriteWord(Word address, Word w);

};

#endif // !defined(AFX_TIMERPODULE1_H__C1A65D8B_3C44_4D33_A5BC_98FEFBE56526__INCLUDED_)
